找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1042|回复: 3

[转贴]:Text2MText

[复制链接]

已领礼包: 593个

财富等级: 财运亨通

发表于 2004-8-14 11:25:20 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×

  1. ;;; Text2MText
  2. ;;; (c) 1995 CR/LF GmbH, Essen/Germany
  3. ;;; Custom AutoCAD Programming since 1986
  4. ;;;
  5. ;;; CR/LF GmbH                               -----------
  6. ;;; Obere Fuhr 27                           |  CR /   | |
  7. ;;; D-45136 Essen                          ||    / LF | |
  8. ;;; Tel.:     ++49 201 254566              || <-------+ |
  9. ;;; Fax:      ++49 201 256669              | -----------
  10. ;;; CIS:      100015,1632                   -----------
  11. ;;; Internet: [email]100015.1632@CompuServe.com[/email]
  12. ;;;
  13. ;;; This program is copyrighted. It may be distributed freely however.
  14. ;;;
  15. ;;; Benefit:
  16. ;;;   This file implements an AutoCAD command to combine selected text lines
  17. ;;;   to a single mtext object.
  18. ;;;
  19. ;;; Usage:
  20. ;;;   Load this file with AutoCAD's APPLOAD command.
  21. ;;;   Enter TEXT2MTEXT.
  22. ;;;   Pick the reference text. The mtext object will use this entity's
  23. ;;;     properties including style, text height, layer a.s.o.
  24. ;;;   Select the other text entities to append to the reference text.
  25. ;;;   Done.
  26. ;;;
  27. ;;; Restrictions:
  28. ;;;   Select the text to combine by clicking. Using crossing or windowing
  29. ;;;   may result in an unwanted text sequence.
  30. ;;;

  31. (defun c:text2mtext (/ dxf ss index ent mtext)
  32.   (defun dxf (tag obj) (cdr (assoc tag obj)))
  33.   (cond
  34.     ((not (setq reftext (car (entsel "Pick reference text"))))
  35.        (princ "Nothing selected"))
  36.     ((not (= (dxf 0 (setq reftext (entget reftext))) "TEXT"))
  37.        (princ "Not a text"))
  38.     ((not (setq ss (ssget)))
  39.        (princ "Nothing selected"))
  40.     (T
  41.      (setq index 0.0
  42.            mtext '((0 . "MTEXT") (100 . "AcDbEntity") (100 . "AcDbMText"))
  43.            mtext (append mtext
  44.                          (list (assoc 8 reftext) (assoc 10 reftext)
  45.                                (assoc 7 reftext) (assoc 40 reftext)
  46.                                (cons 41 (abs (- (caar (textbox reftext))
  47.                                                 (caadr (textbox reftext)))))
  48.                                (cons 3 (strcat (dxf 1 reftext) "\\P"))))
  49.      )
  50.      (entdel (dxf -1 reftext))
  51.      (repeat (sslength ss)
  52.        (cond ((not
  53.                 (= (dxf 0 (setq ent (entget (ssname ss index)))) "TEXT")
  54.               )
  55.                 (princ "Non-text ignored")
  56.              )
  57.              (T (setq mtext (append mtext
  58.                                (list (cons 3 (strcat (dxf 1 ent) "\\P")))))
  59.                 (entdel (dxf -1 ent))
  60.              )
  61.        )
  62.        (setq index (1+ index))
  63.      )
  64.      (entmake (append mtext '((1 . " "))))
  65.     )
  66.   )
  67.   (princ)
  68. )
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
发表于 2004-8-16 10:38:56 | 显示全部楼层
请问是做什么用的?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2004-8-16 11:59:30 | 显示全部楼层
标题已经很清楚了,“单行文字转换为多行文字”。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2004-8-17 19:06:24 | 显示全部楼层
CAD本身有這個工具的啊. 試試看
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-12-18 22:55 , Processed in 0.408336 second(s), 37 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表